//https://www.lawebdelprogramador.com/foros/Java/1707948-programa-el-java-con-botones.html
package estadisticaLiga;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.border.BevelBorder;
import javax.swing.table.DefaultTableModel;

@SuppressWarnings("serial")
public class Estadistica extends JFrame{
	
	private MatrizEquipos matriz;
	private TablaStats tabla;
	private JButton bt_MenosPuntos;
	private JButton bt_MasGolesFavor;
	private JButton bt_TotalGoles;
	
	public Estadistica() {
		iniciarComponentes();
		setTitle("Estadísticas Liga Colombiana");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		pack();
		setLocationRelativeTo(null);
		setResizable(false);
		setVisible(true);
	}
	
	private void iniciarComponentes() {
		//Inicializamos matriz con datos
		matriz = new MatrizEquipos();
		//Construimos la tabla
		String[] cabecera = new String[] {"Posición", "Equipo", "Puntos", "PJ", "V",
				"D", "E", "GF", "GC", "DG"};
		tabla = new TablaStats(matriz.getMatriz(), cabecera);
		tabla.setEnabled(false);
		JScrollPane visorTabla = new JScrollPane(tabla);
		visorTabla.setPreferredSize(new Dimension(750, 345));
		/*
		 * Inicializamos los botones.
		 * Usar HTML para el texto de los botones
		 * nos permite hacer salto de linea y centrar el texto
		 */
		bt_MenosPuntos = new JButton("<html><p style=\"text-align:center\">Equipo con<br>menos puntos</p></html>");
		bt_MenosPuntos.addActionListener(new AccionBotonMenosPuntos());
		bt_MasGolesFavor = new JButton("<html><p style=\"text-align:center\">Equipo con mas<br>goles a favor</p></html>");
		bt_MasGolesFavor.addActionListener(new AccionBotonMasGolesFavor());
		bt_TotalGoles = new JButton("<html><p style=\"text-align:center\">Total de goles de<br>todos los equipos</p></html>");
		bt_TotalGoles.addActionListener(new AccionBotonTotalGoles());
		//Construimos panel principal
		JPanel principal = new JPanel();
		principal.setLayout(new BorderLayout());
		//En el centro irá la tabla
		JPanel centro = new JPanel();
		centro.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20),
				BorderFactory.createBevelBorder(BevelBorder.RAISED)));
		centro.add(visorTabla);
		//En el sur, los botones
		JPanel sur = new JPanel();
		sur.setLayout(new FlowLayout(FlowLayout.CENTER, 70, 20));
		sur.add(bt_MenosPuntos);
		sur.add(bt_MasGolesFavor);
		sur.add(bt_TotalGoles);
		//Juntamos paneles
		principal.add(centro, BorderLayout.CENTER);
		principal.add(sur, BorderLayout.SOUTH);
		//Lo seteamos como contenedor del JFrame
		setContentPane(principal);
	}
	
	/*
	 * Clase interna para modelar una tabla básica para los datos
	 */
	private class TablaStats extends JTable {
		public TablaStats(Object[][] datos, String[] nombresColumna) {
			super(new DefaultTableModel(datos, nombresColumna));
		}
	}
	
	/*
	 * Clases internas para las acciones de los botones
	 */
	private class AccionBotonMenosPuntos implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			JOptionPane.showMessageDialog(null, "El equipo con menos puntos es: " + matriz.equipoConMenosPuntos(),
					"Equipo menos puntos", JOptionPane.INFORMATION_MESSAGE);
		}
	}
	
	private class AccionBotonMasGolesFavor implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			JOptionPane.showMessageDialog(null, "El equipo con más goles a favor: " + matriz.equipoMasGolesFavor(),
					"Equipo más goles a favor", JOptionPane.INFORMATION_MESSAGE);
		}
	}
	
	private class AccionBotonTotalGoles implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			JOptionPane.showMessageDialog(null, "Goles marcados por todos los equipos: " + matriz.golesTotales(),
					"Total goles marcados", JOptionPane.INFORMATION_MESSAGE);
		}
	}

	public static void main(String[] args) {
		
		SwingUtilities.invokeLater(new Runnable() {
			@Override
			public void run() {
				new Estadistica();	
			}
		});

	}

}
